#include "kbmame.h"

int clock=12;
int newdrv=0;
int sramhack=-1;
char gamename[9];
int is_neo=0;
char *savedir;
char *combodir;
int saveslot=0;
int numrom=0;
char *romnames[30];
unsigned long romsizes[30];
int altloader=0;
int force16=0;
int strange=0;
int askip=0;
int autodelay=0;
int nosfix=0;

int cnt68k[23],cntz80[25];

unsigned short shadow[8]={0,0,0,0,0,0,0,0};
unsigned char autofire[]={0,0,0,0};

unsigned char setcombo[]={0,0,0,0};
unsigned short comboa[2048],rcomboa[2048];
unsigned short *combo,*rcombo,*combo1,*combo2;
unsigned short combondx[8]={0,0,0,0,0,0,0,0};
unsigned short comboentries;

int combocount=0;
int combocount2=0;       

void assign_ptr(void **p1,void *p2)
{
  *p1=p2;
}

/* check for ignore dynamic driver (-olddrv in commandline) */
int ignore_dynamic(int argc,char **argv)
{
   int i;
   for (i = 1; i < argc; i++)
     if (stricmp(argv[i],"-olddrv") == 0)
       newdrv=1;   
   return newdrv;
}

/* return the index of a driver */
int find_dynamic(char *s)
{ 
  int i,j;

  j=-1; 
  for (i = 0; drivers[i] && (j == -1); i++)
    {
        if (stricmp(s,drivers[i]->name) == 0)
        {
	    j = i;
	    break;
	  }   
  }  
  return j;
}

/*
  scan forward in given (open) file until it reaches the
  given entry in square brackets. returns 0 on fail, 1 on
  success.
*/
int scan_ini(FILE *f,char *s)
{
  char temp[41];
  char *search;

  search=malloc(strlen(s)+2);
  sprintf(search,"[%s]",s);
  fscanf(f,"%s",temp);
  while ((stricmp(temp,search)!=0) && !feof(f)) 
    fscanf(f,"%s",temp);
  if (feof(f))
    return 0;
  else
    fgets(temp,41,f);
    return 1;
}

/* returns 1 if r points to end of RomModule, 0 otherwise */
int rom_table_end(struct RomModule *r)
{
  int end=0;
  if (r->name==0)
    if (r->offset==0)
      if (r->length==0)
        if (r->crc==0)
          end=1;
  return end;
}

/*
  searches a rom matrix for a given rom filename and returns the index.
  returns 0 on fail, 1 on success
*/
int search_rom(struct RomModule *romtable,char *s)
{
  struct RomModule *temp;
  int i=0,idx=0;

  temp=romtable;
  while (!rom_table_end(temp)) {
    if (temp->name)  {
      if (stricmp(s,temp->name)==0) {
        idx=i;
        break;
      }
    }
    temp++;
    i++;
  }
  return idx;
}

/* build_dynamic_driver, returns -1 on fail, 1 on success */
int build_dynamic_driver(int *game_index)
// To do: intercept failed malloc calls
{
   FILE *f;  
   char fname[128];
   char drivertype[10];
   char s[35];
   char *desc,*manufacturer,*year;
   char isclone[11],clonename[11],temp[41];  
   char hacksram[11];
   int numroms=0;
   struct RomModule *romarr,*temparr;
   int search,i,mgd2_index;

   desc=malloc(51*sizeof(char));
   manufacturer=malloc(51*sizeof(char));
   year=malloc(31*sizeof(char));
   strcpy(fname,"neogeo.drv");  
   f=fopen(fname,"r");
    if (f==NULL) {
      printf("No additional games found.\n");
      return -1;
   }
   if(scan_ini(f,gamename)==0) {
//     printf("Error : Game %s not found in neogeo.drv.",gamename);
     fclose(f);
     return -1;
   } 
   fscanf(f,"%s",isclone);
   if (stricmp(isclone,"CLONE")==0){
     fscanf(f,"%s",clonename); 
     printf("Clone of %s.\n",clonename);
     *game_index=find_dynamic(clonename);
     if (*game_index==-1) {
       printf("Clone error : Master driver %s does not exist.\n",clonename);
       fclose(f);
       return -1;
     }
   }
   fgets(temp,41,f); /* skip C/R */
   fgets(desc,51,f);
   fgets(year,31,f);
   fgets(manufacturer,51,f);
   printf("desc=%s",desc);
   printf("year=%s",year);
   printf("manufacturer=%s",manufacturer);
   fscanf(f,"%s",drivertype);
   fscanf(f,"%i",&numroms);
   
   if (numroms>0) {
     romarr=malloc((numroms+11)*sizeof(struct RomModule));
     temparr=romarr;
   }
   else {
     temparr=(struct RomModule*)drivers[*game_index]->rom;
     romarr=(struct RomModule*)drivers[*game_index]->rom;
     fscanf(f,"%s",s);
     while (stricmp(s,"-1")) {
       search=search_rom(romarr,s);
       if (search) {
         temparr=(struct RomModule*)&drivers[*game_index]->rom[search];
         fscanf(f,"%x",&temparr->crc);
       }
       else {
         printf("Cannot find rom %s to patch CRC.\n",s);
         fclose(f);
         return -1;
       }
       fscanf(f,"%s",s);
     }
     fgets(temp,41,f); /* skip C/R */
   }

   for (i=1;i<=numroms;i++,temparr++) {
     fscanf(f,"%s",s);
     if (stricmp(s,"ROM_REGION")==0) {
       fscanf(f,"%x",&temparr->offset);
       temparr->name=0;
       temparr->length=0;
       temparr->crc=0;
       continue;
     }

     if (stricmp(s,"ROM_REGION_DISPOSE")==0) {
       fscanf(f,"%x",&temparr->offset);
       temparr->offset|=ROMFLAG_DISPOSE;
       temparr->name=0;
       temparr->length=0;
       temparr->crc=0;
       continue;
     }

     if (stricmp(s,"ROM_REGION_OPTIONAL")==0) {
       fscanf(f,"%x",&temparr->offset);
       temparr->offset|=ROMFLAG_IGNORE;
       temparr->name=0;
       temparr->length=0;
       temparr->crc=0;
       continue;
     }

     if (stricmp(s,"ROM_LOAD")==0) {
       temparr->name=malloc(21*sizeof(char));
       fscanf(f,"%s %x %x %x",(char *)temparr->name,(unsigned int*)&temparr->offset,(unsigned int*)&temparr->length,(unsigned int*)&temparr->crc);
       continue;
     }

     if (stricmp(s,"ROM_CONTINUE")==0) {
       fscanf(f,"%x %x",&temparr->offset,&temparr->length);
       temparr->name=0;
       temparr->crc=0;
       continue;
     }

     if (stricmp(s,"ROM_RELOAD")==0) {
       fscanf(f,"%x %x",&temparr->offset,&temparr->length);
       temparr->name=(char *)-1;
       temparr->crc=0;
       continue;
     }

     if (stricmp(s,"ROM_LOAD_WIDE")==0) {
       temparr->name=malloc(21*sizeof(char));
       fscanf(f,"%s %x %x %x",(char*)temparr->name,(unsigned int*)&temparr->offset,(unsigned int*)&temparr->length,(unsigned int*)&temparr->crc);
       temparr->length|=ROMFLAG_WIDE;
       continue;
     }

     if (stricmp(s,"ROM_LOAD_WIDE_SWAP")==0) {
       temparr->name=malloc(21*sizeof(char));
       fscanf(f,"%s %x %x %x",(char*)temparr->name,(unsigned int*)&temparr->offset,(unsigned int*)&temparr->length,(unsigned int*)&temparr->crc);
       temparr->length=temparr->length|ROMFLAG_WIDE|ROMFLAG_SWAP;
       continue;
     }

     if (stricmp(s,"ROM_LOAD_EVEN")==0) {
       temparr->name=malloc(21*sizeof(char));
       fscanf(f,"%s %x %x %x",(char*)temparr->name,(unsigned int*)&temparr->offset,(unsigned int*)&temparr->length,(unsigned int*)&temparr->crc);
       temparr->offset=temparr->offset&~1;
       temparr->length|=ROMFLAG_ALTERNATE;
       continue;
     }

     if (stricmp(s,"ROM_LOAD_ODD")==0) {
       temparr->name=malloc(21*sizeof(char));
       fscanf(f,"%s %x %x %x",(char*)temparr->name,(unsigned int*)&temparr->offset,(unsigned int*)&temparr->length,(unsigned int*)&temparr->crc);
       temparr->offset|=1;
       temparr->length|=ROMFLAG_ALTERNATE;
       continue;
     }

     if (stricmp(s,"NEO_BIOS_SOUND_256K")==0) {
       temparr->name=0;
       temparr->offset=0x20000;
       temparr->length=0;
       temparr->crc=0;
       temparr++;

       temparr->name=malloc(21*sizeof(char));
       strcpy((char*)temparr->name,"neo-geo.rom");
       temparr->offset=0;
       temparr->length=0x20000|ROMFLAG_WIDE|ROMFLAG_SWAP;
       temparr->crc=0x9036d879;
       temparr++;

       temparr->name=0;
       temparr->offset=0x40000;
       temparr->length=0;
       temparr->crc=0;
       temparr++;

       temparr->name=malloc(21*sizeof(char));
       strcpy((char*)temparr->name,"ng-sm1.rom");
       temparr->offset=0;
       temparr->length=0x20000;
       temparr->crc=0x97cf998b;
       temparr++;
       
       temparr->name=malloc(21*sizeof(char));
       fscanf(f,"%s %x",(char*)temparr->name,(unsigned int*)&temparr->crc);
       temparr->offset=0;
       temparr->length=0x40000;
       continue;
     }

     if (stricmp(s,"NEO_BIOS_SOUND_128K")==0) {
       temparr->name=0;
       temparr->offset=0x20000;
       temparr->length=0;
       temparr->crc=0;
       temparr++;

       temparr->name=malloc(21*sizeof(char));
       strcpy((char*)temparr->name,"neo-geo.rom");
       temparr->offset=0;
       temparr->length=0x20000|ROMFLAG_WIDE|ROMFLAG_SWAP;
       temparr->crc=0x9036d879;
       temparr++;

       temparr->name=0;
       temparr->offset=0x40000;
       temparr->length=0;
       temparr->crc=0;
       temparr++;

       temparr->name=malloc(21*sizeof(char));
       strcpy((char*)temparr->name,"ng-sm1.rom");
       temparr->offset=0;
       temparr->length=0x20000;
       temparr->crc=0x97cf998b;
       temparr++;
       
       temparr->name=malloc(21*sizeof(char));
       fscanf(f,"%s %x",(char*)temparr->name,(unsigned int*)&temparr->crc);
       temparr->offset=0;
       temparr->length=0x20000;
       continue;
     }

     if (stricmp(s,"NEO_BIOS_SOUND_64K")==0) {
       temparr->name=0;
       temparr->offset=0x20000;
       temparr->length=0;
       temparr->crc=0;
       temparr++;

       temparr->name=malloc(21*sizeof(char));
       strcpy((char*)temparr->name,"neo-geo.rom");
       temparr->offset=0;
       temparr->length=0x20000|ROMFLAG_WIDE|ROMFLAG_SWAP;
       temparr->crc=0x9036d879;
       temparr++;

       temparr->name=0;
       temparr->offset=0x40000;
       temparr->length=0;
       temparr->crc=0;
       temparr++;

       temparr->name=malloc(21*sizeof(char));
       strcpy((char*)temparr->name,"ng-sm1.rom");
       temparr->offset=0;
       temparr->length=0x20000;
       temparr->crc=0x97cf998b;
       temparr++;
       
       temparr->name=malloc(21*sizeof(char));
       fscanf(f,"%s %x",(char*)temparr->name,(unsigned int*)&temparr->crc);
       temparr->offset=0;
       temparr->length=0x10000;
       continue;
     }

     if (stricmp(s,"NEO_SFIX_128K")==0) {
       temparr->name=0;
       temparr->offset=0x40000|ROMFLAG_DISPOSE;
       temparr->length=0;
       temparr->crc=0;
       temparr++;

       temparr->name=malloc(21*sizeof(char));
       fscanf(f,"%s %x",(char*)temparr->name,(unsigned int*)&temparr->crc);
       temparr->offset=0;
       temparr->length=0x20000;
       temparr++;

       temparr->name=malloc(21*sizeof(char));
       strcpy((char*)temparr->name,"ng-sfix.rom");
       temparr->offset=0x20000;
       temparr->length=0x20000;
       temparr->crc=0x354029fc;
       continue;
     }

     if (stricmp(s,"NEO_SFIX_64K")==0) {
       temparr->name=0;
       temparr->offset=0x40000|ROMFLAG_DISPOSE;
       temparr->length=0;
       temparr->crc=0;
       temparr++;

       temparr->name=malloc(21*sizeof(char));
       fscanf(f,"%s %x",(char*)temparr->name,(unsigned int*)&temparr->crc);
       temparr->offset=0;
       temparr->length=0x10000;
       temparr++;

       temparr->name=malloc(21*sizeof(char));
       strcpy((char*)temparr->name,"ng-sfix.rom");
       temparr->offset=0x20000;
       temparr->length=0x20000;
       temparr->crc=0x354029fc;
       continue;
     }

     if (stricmp(s,"NEO_SFIX_32K")==0) {
       temparr->name=0;
       temparr->offset=0x40000|ROMFLAG_DISPOSE;
       temparr->length=0;
       temparr->crc=0;
       temparr++;

       temparr->name=malloc(21*sizeof(char));
       fscanf(f,"%s %x",(char*)temparr->name,(unsigned int*)&temparr->crc);
       temparr->offset=0;
       temparr->length=0x8000;
       temparr++;

       temparr->name=malloc(21*sizeof(char));
       strcpy((char*)temparr->name,"ng-sfix.rom");
       temparr->offset=0x20000;
       temparr->length=0x20000;
       temparr->crc=0x354029fc;
       continue;
     }

     printf("\nUnrecognized keyword : %s\n",s);
     fclose(f);
     return -1;
   }

   if (numroms>0){
     temparr->name=0;
     temparr->offset=0;
     temparr->length=0;
     temparr->crc=0;
   }
   fscanf(f,"%s",hacksram);
   if (stricmp(hacksram,"SRAMHACK")==0)
     fscanf(f,"%x",&sramhack); 
   fgets(temp,41,f); /* skip C/R */
   if (sramhack!=-1) 
     printf("SRAM : %x\n",sramhack);
   fclose(f);
   assign_ptr((void*)&drivers[*game_index]->rom,(void*)romarr);
   assign_ptr((void*)&drivers[*game_index]->description,(void*)desc);
   assign_ptr((void*)&drivers[*game_index]->year,(void*)year);
   assign_ptr((void*)&drivers[*game_index]->manufacturer,(void*)manufacturer);
   if (stricmp(drivertype,"MGD2")==0) {
     mgd2_index=find_dynamic("dummymgd");
     assign_ptr((void*)&drivers[*game_index]->drv,(void*)drivers[mgd2_index]->drv);
   }
   if (stricmp(drivertype,"MVS")==0) {
     mgd2_index=find_dynamic("dummy");
     assign_ptr((void*)&drivers[*game_index]->drv,(void*)drivers[mgd2_index]->drv);
   }
   if (stricmp(drivertype,"RASTER")==0) {
     mgd2_index=find_dynamic("dummyrst");
     assign_ptr((void*)&drivers[*game_index]->drv,(void*)drivers[mgd2_index]->drv);
   }

   assign_ptr((void*)&drivers[*game_index]->name,(void*)gamename);
   printf("Driver type : %s\n",drivertype);
   printf("Number of items : %d\n",numroms);
   return *game_index;
}


void pokeport(int readport,int button)
/*
  readport=input port to read data from
  button=index of entry in input_ports array
*/
{
  int src,res;
  UINT16 *p;
  UINT16 values[]={0x30,0xc0,0x50,0xa0,0x90,0x60,0x70,0xf0,0xe0,0x05,0x09,0x0a,0x06,0x00,0x100,0x200,0x400,0x800};

  src = readinputport(readport);
  res = src&0x1f;
//  p=(UINT16*)&Machine->input_ports[button].mask;
//  *p=values[res];
  Machine->input_ports[button].mask=values[res];
}

/* To do: This needs to be changed to make it more flexible */
void apply_ports(void)
{
  int i;
  unsigned short j;

/* Read in combo settings */
    for (i=0;i<=3;i++)  {
        j=readinputport(7+i)&0x1F;
        setcombo[i]=j>13?j-13:0;
    }
/* Read in autofire values */
    for (i=0;i<=3;i++)
      autofire[i]=readinputport(i+11);

/* Set autofire delay */
  autodelay=readinputport(15)&0xf;

/* Read in ports 7-10 (button assignments) and assign to p1 */
    pokeport(7,9);
    pokeport(8,10);
    pokeport(9,11);
    pokeport(10,12);
/* Read in ports 7-10 (button assignments) and assign to p2 */
    pokeport(7,22);
    pokeport(8,23);
    pokeport(9,24);
    pokeport(10,25);
}

void set_clock(void)
{
  int *p;
  p=(int*)&Machine->drv->cpu[0].cpu_clock;
  *p=clock*1000000;
}

void save_contexts(void)
{
  FILE *f;
  char fname[128];
  int i,bank=0;
  unsigned char *RAM;

    sprintf(fname,"%s\\%s.%d",savedir,Machine->gamedrv->name,saveslot);
    for (i=1;i<=23;i++)
      cnt68k[i-1]=cpuintf[CPU_M68000].get_reg(i);
    for (i=1;i<=25;i++)
      cntz80[i-1]=cpuintf[CPU_Z80].get_reg(i);
    f=fopen(fname,"wb");
   fwrite(cnt68k,1,sizeof(cnt68k),f);
    fwrite(cntz80,1,sizeof(cntz80),f);
    fwrite(neogeo_ram,1,0x10000,f);
    fwrite(vidram,1,0x10c00,f);
    fwrite(pal_bank1,1,0x2000,f);
    fwrite(pal_bank2,1,0x2000,f);    
    if (neogeo_paletteram==pal_bank2)
      bank=1;
    fwrite(&bank,1,sizeof(bank),f);
    RAM=Machine->memory_region[Machine->drv->cpu[1].memory_region];
    fwrite(&RAM[0xf800],1,0x800,f);
    fclose(f);
}

void restore_contexts(void)
{
    FILE *f;
    char fname[128];
    int i,j,bank;
    unsigned char *RAM;

    sprintf(fname,"%s\\%s.%d",savedir,Machine->gamedrv->name,saveslot);
    f=fopen(fname,"rb");
    if (f==NULL) 
      return;
    osd_sound_enable(0);
    fread(cnt68k,1,sizeof(cnt68k),f); 
    fread(cntz80,1,sizeof(cntz80),f);
    fread(neogeo_ram,1,0x10000,f);
    fread(vidram,1,0x10c00,f);
    fread(pal_bank1,1,0x2000,f);
    fread(pal_bank2,1,0x2000,f);
    fread(&bank,1,sizeof(bank),f);
    RAM=Machine->memory_region[Machine->drv->cpu[1].memory_region];
    fread(&RAM[0xf800],1,0x800,f);
    fclose(f);   
    j=0;
    if (bank==1) {
      for (i=0;i<0x2000;i+=2) {
       neogeo_paletteram_w(j,(pal_bank2[i+1]<<8)+pal_bank2[i]);
       j+=2;
      }
      neogeo_paletteram=pal_bank2;
    }
    else {
      for (i=0;i<0x2000;i+=2) {
       neogeo_paletteram_w(j,(pal_bank1[i+1]<<8)+pal_bank1[i]);
       j+=2;
      }
      neogeo_paletteram=pal_bank1;
    }
    for (i=1;i<=23;i++)
      cpuintf[CPU_M68000].set_reg(i,cnt68k[i-1]);
    for (i=1;i<=24;i++)
      cpuintf[CPU_Z80].set_reg(i,cntz80[i-1]);
    combocount=combocount2=0;
    osd_sound_enable(1);
}

// To do: roll loop for brevity
void readrom2(void)
{
  unsigned char *region,*region2,*base;
  int i;
  unsigned long bpp,bf,bif,tsize;
  char *currom;
  FILE *f;

  tsize=0;
  for (i=0;i<numrom;i++)
    tsize+=romsizes[i];

  i=0;
  region=Machine->memory_region[2];
  region2=Machine->memory_region[3];
  base=region;
  bpp=(tsize/4)/64;
  currom=romnames[i];
  f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);
  bf=0;bif=0;

  do {
    osd_fread(f,base,64);
    bf+=1;bif+=1;
    base+=128;
    if ((bif*64)>=romsizes[i]) {
      if (bf<=bpp) {
        osd_fclose(f);
        i++;
        bif=0;
        currom=romnames[i];
          f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);

      }  
    }
  } while (bf<bpp);

  base=region2;bf=0;
  do {
    osd_fread(f,base,64);
    bf+=1;bif+=1;
    base+=128;
    if ((bif*64)>=romsizes[i]) {
      if (bf<=bpp) {
        osd_fclose(f);
        i++;
        bif=0;
        currom=romnames[i];
        f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);

      }  
    }
  } while (bf<bpp);

  base=region+64;bf=bif=0;
  do {
    osd_fread(f,base,64);
    bf+=1;bif+=1;
    base+=128;
    if ((bif*64)>=romsizes[i]) {
      if (bf<=bpp) {
        osd_fclose(f);
        i++;
        bif=0;
        currom=romnames[i];
        f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);

      }  
    }
  } while (bf<bpp);

  base=region2+64;bf=0;
  do {
    osd_fread(f,base,64);
    bf+=1;bif+=1;
    base+=128;    
    if ((bif*64)>=romsizes[i]) {
      if (bf<bpp) {
        osd_fclose(f);
        i++;
        bif=0;
        currom=romnames[i];
          f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);

      }  
    }
  } while (bf<bpp);

  osd_fclose(f);
}

// To do: halt emulator if rom max exceeded
void addrom(char *name,unsigned long size)
{
    if (numrom>=30)
    printf("Too many roms.\n");
  else {
    romnames[numrom]=malloc(20);
    strcpy(romnames[numrom],name);
    romsizes[numrom]=size;
    numrom++;
  }  
}

// Disabled for this version (new version being tested)
// To do: roll loop for brevity
/*void readrom3(void)
{
  unsigned char *region,*region2,*base;
  int i;
  unsigned long bpp,bf,bif,tsize;
  char *currom;
  FILE *f;

  tsize=0;
  for (i=0;i<numrom;i++) {
    romsizes[i]*=2;
    tsize+=romsizes[i];
  }

  i=0;
  region=Machine->memory_region[2];
  region2=Machine->memory_region[3];
  base=region;
  bpp=(tsize/4)/64;
  currom=romnames[i];
  f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
  osd_fseek(f,romsizes[i]/2,SEEK_SET);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);
  bf=0;bif=0;

  do {
    osd_fread(f,base,64);
    bf+=1;bif+=1;
    base+=128;
    if (bif*64==romsizes[i]/2)
      osd_fseek(f,0,SEEK_SET);
    if ((bif*64)>=romsizes[i]) {
      if (bf<=bpp) {
        osd_fclose(f);
        i++;
        bif=0;
        currom=romnames[i];
          f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
          osd_fseek(f,romsizes[i]/2,SEEK_SET);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);

      }  
    }
  } while (bf<bpp);

  base=region2;bf=0;
  do {
    osd_fread(f,base,64);
    bf+=1;bif+=1;
    base+=128;
    if (bif*64==romsizes[i]/2)
      osd_fseek(f,0,SEEK_SET);
    if ((bif*64)>=romsizes[i]) {
      if (bf<=bpp) {
        osd_fclose(f);
        i++;
        bif=0;
        currom=romnames[i];
        f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
        osd_fseek(f,romsizes[i]/2,SEEK_SET);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);

      }  
    }
  } while (bf<bpp);

  base=region+64;bf=bif=0;
  do {
    osd_fread(f,base,64);
    bf+=1;bif+=1;
    base+=128;
    if (bif*64==romsizes[i]/2)
      osd_fseek(f,0,SEEK_SET);
    if ((bif*64)>=romsizes[i]) {
      if (bf<=bpp) {
        osd_fclose(f);
        i++;
        bif=0;
        currom=romnames[i];
        f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
        osd_fseek(f,romsizes[i]/2,SEEK_SET);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);
  }  
    }
  } while (bf<bpp);

  base=region2+64;bf=0;
  do {
    osd_fread(f,base,64);
    bf+=1;bif+=1;
    base+=128;    
    if (bif*64==romsizes[i]/2)
      osd_fseek(f,0,SEEK_SET);
    if ((bif*64)>=romsizes[i]) {
      if (bf<bpp) {
        osd_fclose(f);
        i++;
        bif=0;
        currom=romnames[i];
          f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
          osd_fseek(f,romsizes[i]/2,SEEK_SET);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);

      }  
    }
  } while (bf<bpp);
  osd_fclose(f);
}
*/

/* Force 16-bit driver */
void force_16(void)
{
  int *p;
  p=(int*)&Machine->drv->video_attributes;   
  *p|=VIDEO_SUPPORTS_16BIT;
}

// This new loader is under testing - some planes may not appear with
// some (a few) roms
void readrom3(void)
{
  unsigned char *region,*region2,*base;
  int i;
  unsigned long bpp,bf,bif,tsize;
  char *currom;
  FILE *f;  

  tsize=0;
  for (i=0;i<numrom;i++) {
    romsizes[i]*=2;
    tsize+=romsizes[i];
  }

  if (strange) {
    romsizes[numrom/2-1]=romsizes[numrom/2-1]/2;
    romsizes[numrom-1]=romsizes[numrom-1]/2;
    tsize=tsize-2*romsizes[numrom-1];
  }
// Debugging code
//  printf("First : %ld\n",romsizes[numrom/2-1]);
//  printf("Second: %ld\n",romsizes[numrom-1]);
//  printf("Total : %ld\n",tsize);
//  printf("Strange=%d\n",strange);
  i=0;
  region=Machine->memory_region[2];
  region2=Machine->memory_region[3];
  base=region;
  bpp=(tsize/4)/64;
  currom=romnames[i];
  f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
  osd_fseek(f,romsizes[i]/2,SEEK_SET);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);
  bf=0;bif=0;

  do {
    osd_fread(f,base,64);
    bf+=1;bif+=1;
    base+=128;
    if (bif*64==romsizes[i]/2)
      osd_fseek(f,0,SEEK_SET);
    if ((bif*64)>=romsizes[i]) {
      if (bf<=bpp) {
        osd_fclose(f);
        i++;
        bif=0;
        currom=romnames[i];
          f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
          osd_fseek(f,romsizes[i]/2,SEEK_SET);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);

      }  
    }
  } while (bf<bpp);

  base=region2;bf=0;
  do {
    osd_fread(f,base,64);
    bf+=1;bif+=1;
    base+=128;
    if ((bif*64==romsizes[i]/2)&&(!strange))
      osd_fseek(f,0,SEEK_SET);
    if ((bif*64)>=romsizes[i]) {
      if (bf<=bpp) {
        osd_fclose(f);
        i++;
        bif=0;
        currom=romnames[i];
        f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
        if (!(strange && (i==numrom/2-1)))
          osd_fseek(f,romsizes[i]/2,SEEK_SET);
        else
          printf("Starting from top : %s\n",romnames[i]);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);

      }  
    }
  } while (bf<bpp);

  base=region+64;bf=bif=0;
  do {
    osd_fread(f,base,64);
    bf+=1;bif+=1;
    base+=128;
    if (bif*64==romsizes[i]/2)
      osd_fseek(f,0,SEEK_SET);
    if ((bif*64)>=romsizes[i]) {
      if (bf<=bpp) {
        osd_fclose(f);
        i++;
        bif=0;
        currom=romnames[i];
        f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
        osd_fseek(f,romsizes[i]/2,SEEK_SET);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);
  }  
    }
  } while (bf<bpp);

  base=region2+64;bf=0;
  do {
    osd_fread(f,base,64);
    bf+=1;bif+=1;
    base+=128;    
    if ((bif*64==romsizes[i]/2)&&(!strange))
      osd_fseek(f,0,SEEK_SET);
    if ((bif*64)>=romsizes[i]) {
      if (bf<bpp) {
        osd_fclose(f);
        i++;
        bif=0;
        currom=romnames[i];
          f=osd_fopen(Machine->gamedrv->name,romnames[i],OSD_FILETYPE_ROM,0);
          if (!(strange && (i==numrom-1)))
            osd_fseek(f,romsizes[i]/2,SEEK_SET);
          else
            printf("Starting from top : %s\n",romnames[i]);
  if (f==0)
    printf("Error loading %s\n",romnames[i]);
  else
    printf("Loading %s\n",romnames[i]);

      }  
    }
  } while (bf<bpp);
  osd_fclose(f);
}

/* Autofire routine */
void do_autofire(unsigned short inparr[])
{
  unsigned short i,j,k;
  askip++;
  if (askip<autodelay) return;
  askip=0;
  for (i=0;i<=1;i++) 
    for (j=0x10,k=0;j<=0x80;j=j<<1,k++) 
      if (autofire[k])
        if (!(inparr[i]&j)) {   
          shadow[i*4+k]=shadow[i*4+k]?0:1;
          if (shadow[i*4+k]) 
            inparr[i]=inparr[i]&(~j);     
          else
            inparr[i]=inparr[i]|j;                    }          
}

/* Macro routine */
void do_macro(unsigned short inparr[],int pressed[])
{
  int i,docombo1=0,docombo2=0;

  combo=comboa;
  rcombo=rcomboa;

  if (!combocount)
    for (i=0;i<4;i++) 
      if (pressed[8+i]&&setcombo[i]) {
        combocount=combondx[setcombo[i]-1];
        if (!pressed[2])
          combo1=comboa;
        else
          combo1=rcomboa;
        docombo1=1;
        break; 
      }

   if (combocount||docombo1) {   
    inparr[0]=combo1[combocount];
    combocount++;
    if (combo1[combocount]==(0xFFFF))
      combocount=0;
   }

  if (!combocount2)
    for (i=0;i<4;i++) 
      if (pressed[20+i]&&setcombo[i]) {
        combocount2=combondx[setcombo[i]-1];
        if (!pressed[15])
          combo2=rcomboa;
        else
          combo2=comboa;        
        docombo2=1;
        break; 
      }

   if (combocount2||docombo2) {   
    inparr[1]=combo2[combocount2];
    combocount2++;
    if (combo2[combocount2]==(0xFFFF))
      combocount2=0;
   }
}

// A lot can be done to make this more readable
int read_combo(void) {
  char temp[10];
  char fname[80];
  char *s;
  FILE *f;
  unsigned int i;
  unsigned int speed=0;
  unsigned short cnt=0,start=0;

  s=(char*)malloc(10);
  memset(comboa,0xff,2048*2);
  memset(rcomboa,0xff,2048*2);
  combo=comboa;
  rcombo=rcomboa;
  sprintf(fname,"%s\\%s.cmb",combodir,Machine->gamedrv->name);
  f=fopen(fname,"rt");
  if (f==NULL)
    return 0;
  fscanf(f,"%d",&speed);
  while (!feof(f)) {
    fscanf(f,"%s",s);
    if (!feof(f)) {
      if (!strcmp(s,"b")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x4;
          rcombo[comboentries++]=~0x8;
        }
      }
      if (!strcmp(s,"f")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x8;
          rcombo[comboentries++]=~0x4;
        }
      }
      if (!strcmp(s,"u")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x1;
          rcombo[comboentries++]=~0x1;
        }
      }
      if (!strcmp(s,"d")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x2;
          rcombo[comboentries++]=~0x2;
        }
      }
      if (!strcmp(s,"ub")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x5;
          rcombo[comboentries++]=~0x9;
        }
      }
      if (!strcmp(s,"uf")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x9;
          rcombo[comboentries++]=~0x5;
        }
      }
      if (!strcmp(s,"db")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x6;
          rcombo[comboentries++]=~0xa;
        }
      }
      if (!strcmp(s,"df")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0xa;
           rcombo[comboentries++]=~0x6;
        }
      }
      if (!strcmp(s,"n")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=0x00ff;
           rcombo[comboentries++]=0x00ff;
        }
      }
      if (!strcmp(s,"A")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x10;
          rcombo[comboentries++]=~0x10;
        }
      }
      if (!strcmp(s,"B")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x20;
          rcombo[comboentries++]=~0x20;
        }
      }
      if (!strcmp(s,"C")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x40;
          rcombo[comboentries++]=~0x40;
        }
      }
      if (!strcmp(s,"D")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x80;
          rcombo[comboentries++]=~0x80;
        }
      }
      if (!strcmp(s,"+")) {
        comboentries-=speed;
        fscanf(f,"%s",s);
        for (i=0;i<speed;i++) {
        if (!strcmp(s,"A")) {        
          combo[comboentries]&=~0x10;
          rcombo[comboentries++]&=~0x10;
        }
        if (!strcmp(s,"B")) {
          combo[comboentries]&=~0x20;
          rcombo[comboentries++]&=~0x20;
        }
        if (!strcmp(s,"C")) {
          combo[comboentries]&=~0x40;
          rcombo[comboentries++]&=~0x40;
        }
        if (!strcmp(s,"D")) {
          combo[comboentries]&=~0x80;
          rcombo[comboentries++]&=~0x80;
        }
        }
      }
      if (!strcmp(s,"qcf")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x2;
          rcombo[comboentries++]=~0x2;
        }
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0xa;
          rcombo[comboentries++]=~0x6;
        }
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x8;
          rcombo[comboentries++]=~0x4;
        }
      }
      if (!strcmp(s,"qcb")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x2;
          rcombo[comboentries++]=~0x2;
        }
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x6;
          rcombo[comboentries++]=~0xa;
        }
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x4;
          rcombo[comboentries++]=~0x8;
        }
      }
      if (!strcmp(s,"hcf")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x4;
          rcombo[comboentries++]=~0x8;
        }
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x6;
          rcombo[comboentries++]=~0xa;
        }
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x2;
          rcombo[comboentries++]=~0x2;
        }
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0xa;
          rcombo[comboentries++]=~0x6;
        }
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x8;
          rcombo[comboentries++]=~0x4;
        }
      }
      if (!strcmp(s,"hcb")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x8;
          rcombo[comboentries++]=~0x4;
        }
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0xa;
          rcombo[comboentries++]=~0x6;
        }
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x2;
          rcombo[comboentries++]=~0x2;
        }
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x6;
          rcombo[comboentries++]=~0xa;
        }
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x4;
          rcombo[comboentries++]=~0x8;
        }
      }
      if (!strcmp(s,"dp")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x8;      
          rcombo[comboentries++]=~0x4;
        }
        for (i=0;i<speed;i++) {          
          combo[comboentries]=~0x2;
          rcombo[comboentries++]=~0x2;
        }
        for (i=0;i<speed;i++) {          
          combo[comboentries]=~0xa;
          rcombo[comboentries++]=~0x6;
        }
      }
      if (!strcmp(s,"rdp")) {
        for (i=0;i<speed;i++) {
          combo[comboentries]=~0x4;      
          rcombo[comboentries++]=~0x8;
        }
        for (i=0;i<speed;i++) {          
          combo[comboentries]=~0x2;
          rcombo[comboentries++]=~0x2;
        }
        for (i=0;i<speed;i++) {          
          combo[comboentries]=~0x6;
          rcombo[comboentries++]=~0xa;
        }
      }
      if (!stricmp(s,"end")) {
        combo[comboentries]=0xffff;
        rcombo[comboentries++]=0xffff;
        fgets(temp,10,f);
        combondx[cnt++]=start;
        start=comboentries;
        if (!feof(f)) 
          fscanf(f,"%d",&speed);
        if (cnt>=8) break;
      }
      if (atoi(s)!=0)
        speed=atoi(s);
    }
  }
  fclose(f);  
  return cnt;
}

void kbmame_init(void) {  
  printf("Combos loaded : %d\n",read_combo());
  if (force16) 
    force_16();  
  set_clock();
}
